#include "OgreRenderTechnique.h"
#include "OgreTechniqueGroup.h"
#include "OgrePass.h"

using namespace Ogre;

OgreRenderTechnique::OgreRenderTechnique(
						Pass* pass,
						OgreRenderable* parentRenderable,
						OgreTechniqueGroup* parentTechniqueGroup)
						:RenderTechnique(parentRenderable, parentTechniqueGroup)
{
	this->pass = pass;
	this->parentOgreRenderable = parentRenderable;
	this->parentOgreTechniqueGroup = parentTechniqueGroup;
	this->sharedRuns = parentTechniqueGroup->getSharedRuns();
}

OgreRenderTechnique::~OgreRenderTechnique()
{

}

void RenderTechniqueFactory::parseParams(IllumTechniqueParams* params)
{
	NameValuePairList parameters = params->getParams();

	NameValuePairList::iterator it = parameters.begin();
	NameValuePairList::iterator itend = parameters.end();

	while(it != itend)
	{
		AttribParserList::iterator i = attributeParsers.find(it->first);

		if(i == attributeParsers.end())
		{
			 LogManager::getSingleton().logMessage("Unknown parameter type found while parsing illummodule technique params!");
		}
		else
		{
			i->second(it->second, this);
		}

		it++;
	}
}

